<template>
  <app-form title="Create Card" :open="open" @close="cancelCreate">
    <form-group labelFor="form-create-card-name" label="Card Name">
      <form-input
        id="form-create-card-name"
        v-model="name"
        placeholder="Please Provide the name of the Card..."
      ></form-input>
    </form-group>
    <template v-slot:footer>
      <button @click="createCard" type="button" class="btn btn-primary">
        Create
      </button>
      <button @click="cancelCreate" type="button" class="btn btn-light">
        Cancel
      </button>
    </template>
  </app-form>
</template>

<script lang="ts">
import { defineComponent, PropType } from "vue";
import { v4 as uuidV4 } from "uuid";
import AppForm from "../components/Form.vue";
import FormGroup from "../components/FormGroup.vue";
import FormInput from "../components/FormInput.vue";
import { Card, List } from "@/core/database";

export default defineComponent({
  components: { AppForm, FormGroup, FormInput },
  emits: ["create", "cancel"],
  props: {
    open: {
      type: Boolean,
      required: true,
    },
    list: {
      type: Object as PropType<List>,
      required: true,
    },
  },
  data() {
    return {
      name: "",
      description: "",
      date: new Date(),
    };
  },
  methods: {
    createCard() {
      const newCard = new Card(
        uuidV4(),
        this.name,
        this.list.id,
        this.description,
        this.date
      );
      this.$emit("create", newCard);
      this.cancelCreate();
    },
    cancelCreate() {
      this.$emit("cancel");
    },
  },
});
</script>
